       SUBROUTINE RCONV(INTYP,OUTYP,LRDAT,ICOUNT) 
C=============================================================================
C This routine carries out data conversion for READ*4 numbers between the 
C following processors:
C
C       Processor TYPE  1       INTEL  (little endian byte)
C                 TYPE  2       Dec VMS and RSX  (big endian word)
C                 TYPE  3       Silicon Graphics  (big endian byte)
C
C       INTYP   = processor type of input data
C       OUTYP   = processor type of output data
C       LRDAT   = vector array of REAL*4 numbers to be converted
C       ICOUNT  = number of READ*4 numbers to be processed in this call
C
C       Programmer: Andrew Danis                 19-Feb-1993
C=============================================================================
        INTEGER*1 LRDAT(1)
        INTEGER*2 INTYP,OUTYP

        INTEGER*2 SWAP_LIST(4,3,3)
        INTEGER*2 EXP_BYTE(3)
        INTEGER*2 EXP_ADD(3,3)
        INTEGER*2 ADD,EXP

        INTEGER*2 ISL(4)
        INTEGER*1 LI(4),LO(4),LO_OR

        DATA SWAP_LIST/ 1,2,3,4,  3,4,1,2,  4,3,2,1,
     *                  3,4,1,2,  1,2,3,4,  2,1,4,3,
     *                  4,3,2,1,  2,1,4,3,  1,2,3,4/

        DATA EXP_BYTE/  4,2,1/
        DATA EXP_ADD/   0,-1,0,1,0,1,0,-1,0/
C----------------------------------------------------------------------------
        IF(INTYP.EQ.OUTYP) RETURN

        ADD=EXP_ADD(INTYP,OUTYP)
        EXP=EXP_BYTE(OUTYP)

        DO 10 I=1,4
10         ISL(I)=SWAP_LIST(I,INTYP,OUTYP)

        K=0
        DO 30 J=1,ICOUNT
           DO 20 I=1,4
20             LO(ISL(I))=LRDAT(I+K)
           LO_OR=LO(1).OR.LO(2).OR.LO(3).OR.LO(4)
           IF (LO_OR.NE.0) LO(EXP)=LO(EXP)+ADD

           DO 50 L=1,4
50             LRDAT(L+K)=LO(L)

           K=K+4
30      CONTINUE

        RETURN
        END


